%define prog kernel
%define kmaj 2.4
%define kmin 32

Summary:     The Linux kernel for the Soekris net4801
Name:        %{prog}-net4801
Version:     %{kmaj}.%{kmin}
Release:     7.el3.pp
License:     GPL
Group:       System Environment/Kernel
Source0:     ftp://ftp.%{prog}.org/pub/linux/%{prog}/v%{kmaj}/linux-%{version}.tar.bz2
Source1:     %{name}.config
Source2:     COPYING.modules
Source3:     linux-rhconfig.h
Source4:     http://www.soekris.com/Software/linux_2_4_dp83815.tar.gz
Source6:     http://www2.lm-sensors.nu/~lm78/archive/i2c-2.9.2.tar.gz
Source7:     http://www2.lm-sensors.nu/~lm78/archive/lm_sensors-2.9.2.tar.gz
Source8:     http://soekris.hejl.de/gpio-1.3.2.tar.gz
Source9:     ftp://ftp.%{prog}.org/pub/linux/daemons/ntp/pps/PPSkit-2.1.6.tar.gz
Patch0:      linux-2.4.0-nonintconfig.patch
Patch1:      http://www.sk-tech.net/support/net4801.%{prog}.patch_2.4.31
Patch2:      http://www.da-cha.org/geode/patch-2.4-oostore.pp
Patch3:      linux-2.4.32-dp83815.patch
Patch4:      ftp://ftp.%{prog}.org/pub/linux/%{prog}/people/rml/procps-rt/v%{kmaj}/proc-add-rt-info-rml-2.4.20-pre10-1.patch
Patch5:      linux-2.4.17-sem_tuning.patch.pp
Patch7:      http://www.xmailserver.org/linux-patches/epoll-lt-2.4.31-0.22.diff.pp
Patch8:      ftp://ftp.%{prog}.org/pub/linux/%{prog}/people/rml/vm/low-latency-zap_page_range/v%{kmaj}/zap_page_range-rml-2.4.19-pre9-ac3-1.patch
Patch9:      ftp://ftp.%{prog}.org/pub/linux/%{prog}/people/rml/O_STREAMING/v%{kmaj}/O_STREAMING-rml-2.4.20-pre9-1.patch
Patch10:     ftp://ftp.%{prog}.org/pub/linux/%{prog}/people/rml/netdev-random/v%{kmaj}/netdev-random-core-rml-2.4.26-pre5.patch
Patch11:     ftp://ftp.%{prog}.org/pub/linux/%{prog}/people/rml/netdev-random/v%{kmaj}/netdev-random-drivers-rml-2.4.26-pre5.patch.pp
Patch14:     linux-2.4.17-wccp_v2.patch
Patch15:     linux-2.4.32-gpio.patch
Patch16:     linux-2.4.32-serial_latency.patch
URL:         http://www.%{prog}.org/
Buildroot:   /var/tmp/%{name}-root
Vendor:      Linus Torvalds
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Requires:    modutils >= 2.4.18 initscripts >= 5.83 mkinitrd >= 3.2.6
Provides:    %{name}.pp kernel-PPSkit = 2.1.6
Conflicts:   ppp <= 2.3.15 mount < 2.10r-5 nfs-utils < 0.3.1
Conflicts:   e2fsprogs < 1.22 kudzu <= 0.92 initscripts < 6.41
Conflicts:   dev < 3.2-7 iptables < 1.2.5-3 ipsec-tools <= 0.2.2-5
Conflicts:   lm_sensors < 2.9.2
Prereq:      coreutils
BuildPrereq: compat-gcc >= 2.96-98 modutils >= 2.4.21-1 patch >= 2.5.4
BuildPrereq: bash >= 2.03 sh-utils tar bzip2 findutils dev gzip
BuildPrereq: m4 perl
ExclusiveArch: i386 i586
ExclusiveOS: linux

%description
The %{name} package contains the adapted Linux kernel (vmlinuz)
for the AMD Geode SC1100 based Soekris (http://www.soekris.com/) net4801
board.


%package doc
Summary:     The docs from the Linux kernel source
Group:       Documentation
Provides:    %{name}-doc.pp

%package source
Summary:     The source code for the Linux kernel
Group:       Development/System
Provides:    %{name}-source.pp
Requires:    compat-gcc >= 2.96-98 gawk make


%description doc
The %{name}-doc package contains documentation files from the
Linux kernel source. Various bits of information about the Linux kernel
and the device drivers shipped with it are documented in these files.

%description source
The %{name}-source package contains the source code files
for the Linux kernel. These source files are needed to build custom
device drivers. The source files can also be used to build a custom
kernel that is better tuned to your particular hardware.


%prep
%setup -q -n linux-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch4 -p1
%patch5 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch14 -p4
%patch16 -p1

# Prepare addons
mkdir -p addons/dp83815

tar xzf %{SOURCE4} -C addons/dp83815
pushd addons/dp83815
mv *.c *.h ../../drivers/net
popd
%patch3 -p1

tar xzf %{SOURCE9} -C addons
pushd addons/PPSkit-*
cp patch-%{version} ..
popd
patch -p1 < addons/patch-%{version}

tar xzf %{SOURCE6} -C addons
pushd addons/i2c-*
mkpatch/mkpatch.pl . ../.. > ../linux-2.4.32-i2c.patch
popd
patch -p1 < addons/linux-2.4.32-i2c.patch

tar xzf %{SOURCE7} -C addons
pushd addons/lm_sensors-*
mkpatch/mkpatch.pl . ../.. > ../linux-2.4.32-lm_sensors.patch
popd
patch -p1 < addons/linux-2.4.32-lm_sensors.patch

tar xzf %{SOURCE8} -C addons
pushd addons/gpio-*
chmod a-x *
mkdir ../../drivers/char/gpio
mv common.* 4501driver.* 4801driver.* ../../drivers/char/gpio
mv readme.txt ../../Documentation/gpio.txt
popd
%patch15 -p1

# Cleanup
rm -rf addons

mkdir configs
cp %{SOURCE1} configs
cp %{SOURCE2} Documentation

# Remove unwanted files
find . -name "*.orig" -exec rm -fv {} \;
find . -name "*~" -exec rm -fv {} \;


%build
make -s mrproper

cp configs/%{name}.config .config
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}/" Makefile
perl -p -i -e "s/gcc/gcc296/" Makefile

%ifarch i586
make -s oldconfig
make -s oldconfig
make -s scripts/mkdep
make -s depend clean
make -s include/linux/version.h

make -s bzImage || exit 1
make -s modules || exit 1
%endif


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/boot
mkdir -p ${RPM_BUILD_ROOT}/%{_lib}/modules/%{version}-%{release}
mkdir -p ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}

%ifarch i386
tar cf - . | tar xf - -C ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}custom/" \
	${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}/Makefile
install -m 0644 %{SOURCE2} ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}

make -s oldconfig_nonint        -C ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}
make -s oldconfig_nonint        -C ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}
make -s symlinks                -C ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}
make -s include/linux/version.h -C ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}
make -s depend clean            -C ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}

find ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version} -name ".*depend" | \
	while read file ; do
	  mv $file $file.old
	  sed -e "s|[^ \t]*\(/usr/src/kernel\)|\1|g" < $file.old > $file
	  rm -f $file.old
	done

install -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}/include/linux/rhconfig.h
rm -f ${RPM_BUILD_ROOT}%{_usrsrc}/%{name}-%{version}/{drivers/net/hamradio/soundmodem/gentbl,scripts/mkdep}
%endif

%ifarch i586
install -m 0644 System.map ${RPM_BUILD_ROOT}/boot/System.map-%{version}-%{release}
install -m 0644 configs/%{name}.config ${RPM_BUILD_ROOT}/boot/config-%{version}-%{release}
cp arch/i386/boot/*mage ${RPM_BUILD_ROOT}/boot/vmlinuz-%{version}-%{release}
cp vmlinux              ${RPM_BUILD_ROOT}/boot/vmlinux-%{version}-%{release}
make -s \
	INSTALL_MOD_PATH=${RPM_BUILD_ROOT} \
	modules_install                    \
	KERNELRELEASE=%{version}-%{release}
find ${RPM_BUILD_ROOT}/%{_lib}/modules/%{version}-%{release} -name "*.o" -type f | \
	xargs chmod 0744
rm -f  ${RPM_BUILD_ROOT}/%{_lib}/modules/%{version}-%{release}/modules.*
rm -rf ${RPM_BUILD_ROOT}/%{_lib}/modules/%{version}-%{release}/pcmcia

for i in ${RPM_BUILD_ROOT}/%{_lib}/modules/*; do
  rm -f $i/build
  ln -sf ../../..%{_usrsrc}/%{name}-%{version} $i/build
done
%endif


%pre
modprobe loop 2>/dev/null >/dev/null || :


%post
[ -x %{_sbindir}/module_upgrade ] && %{_sbindir}/module_upgrade
[ -x /sbin/mkkerneldoth ] && /sbin/mkkerneldoth
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{version}-%{release}
[ -e /dev/epoll ] || mknod /dev/epoll c 10 124
exit 0

%post source
rm -f %{_usrsrc}/linux-%{kmaj}
ln -snf %{name}-%{version} %{_usrsrc}/linux-%{kmaj}


%preun
modprobe loop 2>/dev/null >/dev/null || :
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{version}-%{release}
exit 0


%postun source
if [ -L %{_usrsrc}/linux-%{kmaj} ]; then
  if [ `ls -ld %{_usrsrc}/linux-%{kmaj} 2>/dev/null | awk '{ print $11 }'` = "%{name}-%{version}" ]; then
    [ $1 = 0 ] && rm -f %{_usrsrc}/linux-%{kmaj}
  fi
fi
exit 0


%triggerin -- kudzu
[ -x %{_sbindir}/module_upgrade ] && %{_sbindir}/module_upgrade || :


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%ifarch i586
%files
%defattr(-,root,root)
/boot/vmlinu?-%{version}-%{release}
/boot/System.map-%{version}-%{release}
/boot/config-%{version}-%{release}
%dir /%{_lib}/modules
%dir /%{_lib}/modules/%{version}-%{release}
/%{_lib}/modules/%{version}-%{release}/build
/%{_lib}/modules/%{version}-%{release}/kernel
%endif

%ifarch i386
%files doc
%defattr(-,root,root)
%doc Documentation/*

%files source
%defattr(-,root,root)
%dir %{_usrsrc}/%{name}-%{version}
%{_usrsrc}/%{name}-%{version}/COPYING*
%{_usrsrc}/%{name}-%{version}/CREDITS
%{_usrsrc}/%{name}-%{version}/Documentation
%{_usrsrc}/%{name}-%{version}/MAINTAINERS
%{_usrsrc}/%{name}-%{version}/Makefile
%{_usrsrc}/%{name}-%{version}/README
%{_usrsrc}/%{name}-%{version}/REPORTING-BUGS
%{_usrsrc}/%{name}-%{version}/Rules.make
%{_usrsrc}/%{name}-%{version}/arch
%{_usrsrc}/%{name}-%{version}/configs
%{_usrsrc}/%{name}-%{version}/crypto
%{_usrsrc}/%{name}-%{version}/drivers
%{_usrsrc}/%{name}-%{version}/fs
%{_usrsrc}/%{name}-%{version}/include
%{_usrsrc}/%{name}-%{version}/init
%{_usrsrc}/%{name}-%{version}/ipc
%{_usrsrc}/%{name}-%{version}/kernel
%{_usrsrc}/%{name}-%{version}/lib
%{_usrsrc}/%{name}-%{version}/mm
%{_usrsrc}/%{name}-%{version}/net
%{_usrsrc}/%{name}-%{version}/scripts
%{_usrsrc}/%{name}-%{version}/.config*
%{_usrsrc}/%{name}-%{version}/.*depend
%endif


%changelog
* Wed Apr 05 2006 peter.pramberger@member.fsf.org
- kernel-net4801 2.4.32-7.el3.pp released
- added:
-   Serial Line Latency Optimization
- removed (PPS conflict):
-   Variable HZ
-   Preempt-Kernel/Lock-Break

* Sun Apr 02 2006 peter.pramberger@member.fsf.org
- kernel-net4801 2.4.32-6.el3.pp released
- added:
-   PPSkit 2.1.6

* Sat Mar 11 2006 peter.pramberger@member.fsf.org
- kernel-net4801 2.4.32-5.el3.pp released

* Thu Mar 09 2006 peter.pramberger@member.fsf.org
- working on kernel 2.4.32
- added:
-   DP8381x Ethernet Driver
-   I2C and LMsensors 2.9.2
-   GPIO Driver 1.3.2 
-   AMD Geode Optimizations
-   Proc Realtime Info
-   Semaphore SEMMNI Tuning
-   Variable HZ
-   EPOLL 0.22
-   Preempt-Kernel/Lock-Break
-   Zap_Page_Range Optimization
-   O_STREAMING Support
-   Entropy Gathering via Network
-   WCCPv2 Redirect Module 1.1

